<template>
  <div
    class="flex gap-2"
    :class="widthClass ? widthClass : 'w-full'"
    ref="tagsGroup"
  >
    <template
      v-for="(tag, index) in shrinkedTags"
      :key="index"
    >
      <svn-pro-info-tag
        :text="tag"
        tag-type="info"
        tag-size="compact"
        :tag-style="tagStyle"
        :break-all="breakAll"
      />
    </template>
  </div>
</template>

<script setup>

import { onMounted, ref, watch } from "vue";
import SvnProInfoTag from "../chip/SvnProInfoTag.vue";

const props = defineProps({
  tags: {
    type: Array,
    default: () => []
  },
  tagStyle: {
    type: String,
    default: "outlined",
  },
  widthClass: {
    type: String,
    default: undefined,
  },
  breakAll: {
    type: Boolean,
    default: true,
  },
})

const tagsGroup = ref(null)
const tagsGroupWitdh = ref(0)
const windowWidth = ref(0)
const shrinkedTags = ref([])
let tagsGroupResizeObserver

onMounted(() => {
  tagsGroupResizeObserver = new ResizeObserver(entries => {
    for (let entry of entries) {
      tagsGroupWitdh.value = entry.contentRect.width;
      windowWidth.value = window.innerWidth
    }
  });
  if (tagsGroup.value) {
    tagsGroupResizeObserver.observe(tagsGroup?.value);
  }
})

watch(tagsGroupWitdh, () => {
  shrinkTags()
})

const shrinkTags = () => {
  const parentWidth = tagsGroup?.value?.offsetWidth / 1.25

  let tagsWidth = 0
  let lastTag = false
  shrinkedTags.value = []

  if (props?.tags?.length) {
    props?.tags?.forEach((tag, index) => {
      if (!lastTag) {
        if (parentWidth > tagsWidth + tag?.length * 8.5) {
          tagsWidth += tag?.length * 9
          shrinkedTags?.value?.push(tag)
        } else {
          shrinkedTags?.value?.push(`+${props?.tags?.length - index}`)
          lastTag = true
        }
      }
    })
  }
}

</script>

<style scoped>

</style>